Monday, July 30, 2007

Fat Jar Plugin for Europa release

There are quite a few bugs on Fat Jar Tracker lately, some of them related to incompatibility with Eclipse 3.3 release (aka. Europa). It's been a long time since I touched the code-base of Fat Jar plug-in, There were several Eclipse 3.3 API incompatibilities including setSorter(ResourceSorter rs) method, now deprecated, and replaced with setSorter(ResourceComparator rc) in org.eclipse.ui.dialogs.ElementTreeSelectionDialog class etc. I'm glad to have no other major, and painful, changes :) (at least, I haven't encounter one so far).

If you are code freak, changes are committed to cvs repository at fjep.cvs.sf.net. For the users, Since I'm just a developer member of the project, I don't have enough rights to upload the build and release the plug in officially, all I can do is to provide you a link for the latest build which works with Europa release. As of this time, I'm not sure when the latest plug in will be available from sf.net, in the mean time you can download it from here.

Enjoy Deployment with Europa :)!

4 comments:

KetanPadegaonkar said...

How you maintain compatibility with older eclipse versions, and still make things work with europa would be an interesting thing to look at :)

Nirav Thaker said...

Oh yes, that's interesting. There's a cool technique already being used.

This technique is used in Eclipse 3.0 to provide backward-compatibility support for plug-ins based on Eclipse 2.1 or earlier. The plug-in org.eclipse.ui.workbench defines a library called compatibility.jar at the start of its classpath. When the platform detects a plug-in written prior to Eclipse 3.0, a fragment called org.eclipse.ui.workbench.compatibility containing compatibility.jar is automatically added to the plug-in’s classpath. This library adds back some old API that was moved in Eclipse 3.0. The beauty of this mechanism is that it allows the backward-compatibility support to be added or removed with no impact on the host plug-in.

http://wiki.eclipse.org/index.php/FAQ_Can_fragments_be_used_to_patch_a_plug-in%3F

Nirav Thaker said...

that link got messed up, follow this
Link .

Sami Khan said...

This still doesn't work with the latest Europa, do not install at the risk of screwing up your config. If you did install, revert to the previous config as it will mess up your configuration as seen through Help > Software Update > Manage Configuration. The items disappear in manage configuration or you might get two items for each thing installed if you remove the jar file from the plugins directory. Fatjar still needs more work.